<template>
  <article v-if='___debug__' class='container'>
    <div class='article'>
      <h5>Vuex State</h5>
      <ul id='vuex-state'>
        <div v-for='[k, v] in Object.entries(state)' :key='k'>
          <li class='mb-0' v-if="k != 'context' && k != '$apispecs'&& !k.startsWith ('__')"><code><b>{{ k }}</b>: {{ v }}</code></li>
        </div>
        <li><b>$apispecs</b>
          <ul>
            <li class='mb-0' v-for='[k, v] of Object.entries(state.$apispecs)' :key='k'>
              <code><button class="btn btn-sm fs-14px py-0" @click="toggleSpecs [k] = !toggleSpecs [k]"><b>{{ k }}</b></button>
                <pre v-if="toggleSpecs [k]"><div class="fw-bold py-2">{{ k }}</div>{{ JSON.stringify (v, null, 2) }}</pre>
              </code>
            </li>
          </ul>
        </li>
        <li v-if="!!state.context"><b>context</b>
          <ul>
            <li class='mb-0' v-for='[k, v] of Object.entries(state.context)' :key='k'>
              <code><b>{{ k }}</b> <pre>{{ JSON.stringify (v, null, 2) }}</pre></code>
            </li>
          </ul>
        </li>
      </ul>
    </div>
    <div class='router' v-if="router">
      <h5>Vue Router</h5>
      <ul>
        <li class='mb-0'><code>route: {{ route }}</code> </li>
        <li class='mb-0'><code>router.options.base: "{{ router.options.base }}" </code></li>
        <li class='mb-0'><code>router.options.routes</code>
          <ul>
            <li v-for='r of router.options.routes' :key='r.name'><code>{{ r }}</code></li>
          </ul>
        </li>
      </ul>
    </div>
  </article>
</template>

<style>
code {
  font-size: 14px !important;
}
</style>

<script setup>
  const ___debug__ = __debug__
  const { state } = useStore ()
  let router
  let route

  if (useRouter)  {
    router = useRouter ()
    route = useRoute ()
  } else {
    router = null
    route = null
  }

  const toggleSpecs = ref ({})
  onMounted (() => {
    for (const [k, v] of Object.entries(state.$apispecs)) {
      toggleSpecs.value [k] = false
    }
  })

</script>
